import type { NodePath } from '@babel/traverse';
import type * as Babel from '@babel/core';
import type { types as t } from '@babel/core';
import { ImportUtil } from 'babel-import-util';
export declare type EmberPrecompile = (templateString: string, options: Record<string, unknown>) => string;
export declare type LegacyModuleName = 'ember-cli-htmlbars' | 'ember-cli-htmlbars-inline-precompile' | 'htmlbars-inline-precompile';
export interface Options {
    outputModuleOverrides?: Record<string, Record<string, [string, string]>>;
    enableLegacyModules?: LegacyModuleName[];
}
interface State {
    opts: Options;
    util: ImportUtil;
    precompile: EmberPrecompile;
    templateFactory: {
        moduleName: string;
        exportName: string;
    };
    program: NodePath<t.Program>;
}
export default function makePlugin<O>(loadPrecompiler: (opts: O) => EmberPrecompile): (babel: typeof Babel) => Babel.PluginObj<State>;
export {};
